const async = require('async');
const fs = require('fs');
const CryptoJS = require('crypto-js');

const Sources = require("webpack-sources");
const {ConcatSource} = Sources

class HelloPlugin {
  constructor(options) {
    this.options = options || {};
  }

  apply(compiler) {
    const options = this.options

    compiler.plugin("compilation", (compilation) => {
      compilation.plugin("optimize-assets", (assets, callback) => {
        async.forEach(Object.keys(assets), (file, cb) => {
          const asset = assets[file];
          let content = asset.source();

          var ciphertext = CryptoJS.AES.encrypt(content.toString(), '123').toString();

          // var bytes  = CryptoJS.AES.decrypt(ciphertext.toString(), '123');
          // var plaintext = bytes.toString(CryptoJS.enc.Utf8);

          assets[file] = new ConcatSource(ciphertext);

          cb();
        }, callback);
      });
    });
  }
}

module.exports = HelloPlugin;
